from http import HTTPStatus
from typing import Any
from urllib.parse import quote

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...models.bulk_order_dto import BulkOrderDto
from ...models.cws_error_dto import CwsErrorDTO
from ...models.mixed_bag_order_dto import MixedBagOrderDTO
from ...types import Response


def _get_kwargs(
    customer_ekp: str,
    *,
    body: MixedBagOrderDTO,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> dict[str, Any]:
    headers: dict[str, Any] = {}
    headers["Authorization"] = authorization

    _kwargs: dict[str, Any] = {
        "method": "post",
        "url": "/dpi/shipping/v1/bulk/{customer_ekp}/mixedorders".format(
            customer_ekp=quote(str(customer_ekp), safe=""),
        ),
    }

    _kwargs["json"] = body.to_dict()

    headers["Content-Type"] = "application/json"

    _kwargs["headers"] = headers
    return _kwargs


def _parse_response(
    *, client: AuthenticatedClient | Client, response: httpx.Response
) -> BulkOrderDto | CwsErrorDTO | None:
    if response.status_code == 200:
        response_200 = BulkOrderDto.from_dict(response.json())

        return response_200

    if response.status_code == 403:
        response_403 = CwsErrorDTO.from_dict(response.json())

        return response_403

    if response.status_code == 404:
        response_404 = CwsErrorDTO.from_dict(response.json())

        return response_404

    if response.status_code == 422:
        response_422 = CwsErrorDTO.from_dict(response.json())

        return response_422

    if response.status_code == 500:
        response_500 = CwsErrorDTO.from_dict(response.json())

        return response_500

    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(
    *, client: AuthenticatedClient | Client, response: httpx.Response
) -> Response[BulkOrderDto | CwsErrorDTO]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    customer_ekp: str,
    *,
    client: AuthenticatedClient | Client,
    body: MixedBagOrderDTO,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[BulkOrderDto | CwsErrorDTO]:
    """Create a Mixed Order

     Creates a new mixed order based on the given data.

    Args:
        customer_ekp (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.
        body (MixedBagOrderDTO):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[BulkOrderDto | CwsErrorDTO]
    """

    kwargs = _get_kwargs(
        customer_ekp=customer_ekp,
        body=body,
        authorization=authorization,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


def sync(
    customer_ekp: str,
    *,
    client: AuthenticatedClient | Client,
    body: MixedBagOrderDTO,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> BulkOrderDto | CwsErrorDTO | None:
    """Create a Mixed Order

     Creates a new mixed order based on the given data.

    Args:
        customer_ekp (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.
        body (MixedBagOrderDTO):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        BulkOrderDto | CwsErrorDTO
    """

    return sync_detailed(
        customer_ekp=customer_ekp,
        client=client,
        body=body,
        authorization=authorization,
    ).parsed


async def asyncio_detailed(
    customer_ekp: str,
    *,
    client: AuthenticatedClient | Client,
    body: MixedBagOrderDTO,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[BulkOrderDto | CwsErrorDTO]:
    """Create a Mixed Order

     Creates a new mixed order based on the given data.

    Args:
        customer_ekp (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.
        body (MixedBagOrderDTO):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[BulkOrderDto | CwsErrorDTO]
    """

    kwargs = _get_kwargs(
        customer_ekp=customer_ekp,
        body=body,
        authorization=authorization,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)


async def asyncio(
    customer_ekp: str,
    *,
    client: AuthenticatedClient | Client,
    body: MixedBagOrderDTO,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> BulkOrderDto | CwsErrorDTO | None:
    """Create a Mixed Order

     Creates a new mixed order based on the given data.

    Args:
        customer_ekp (str):
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.
        body (MixedBagOrderDTO):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        BulkOrderDto | CwsErrorDTO
    """

    return (
        await asyncio_detailed(
            customer_ekp=customer_ekp,
            client=client,
            body=body,
            authorization=authorization,
        )
    ).parsed
